#pragma once
#include <algorithm>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <vector>
#include <thread>
#include <string>
#include <map>
#include <set>
#include <mutex>
#include <sstream>
